// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.editor.handler;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.handlers.HandlerUtil;

import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.TaxonEditorInput;

/**
 * @author n.hoffmann
 * @created 21.04.2009
 * @version 1.0
 */
public class CreateChildTaxonHandler extends AbstractHandler implements
		IHandler {
	private static final Logger logger = Logger
			.getLogger(CreateChildTaxonHandler.class);

	/* (non-Javadoc)
	 * @see org.eclipse.core.commands.IHandler#execute(org.eclipse.core.commands.ExecutionEvent)
	 */
	public Object execute(ExecutionEvent event) throws ExecutionException {
		
		IEditorInput input = HandlerUtil.getActiveEditor(event).getEditorInput();
		if (input instanceof TaxonEditorInput) {
			TaxonNode parentNode = ((TaxonEditorInput) input).getTaxonNode();
			try {
				EditorUtil.openEmpty(parentNode.getUuid());
			} catch (PartInitException e) {
				logger.error("Error opening the editor", e);
			}
		}
		return null;
	}
}
