/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.entitysections;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.IdentifiableSource;
import eu.etaxonomy.taxeditor.forms.TextWithLabelComposite;
import eu.etaxonomy.taxeditor.forms.selectioncomposites.ReferenceSelectionComposite;

/**
 * 
 * @author n.hoffmann
 * @created Nov 16, 2009
 * @version 1.0
 */
public class IdentifiableSourceComposite extends AbstractEntitySetElementComposite<IdentifiableSource>{

	/**
	 * @param parent
	 * @param element
	 * @param removeListener
	 * @param propertyChangelistener
	 * @param style
	 */
	public IdentifiableSourceComposite(Composite parent, IdentifiableSource element,
			SelectionListener removeListener,
			IPropertyChangeListener propertyChangelistener, int style) {
		super(parent, element, removeListener, propertyChangelistener, style);
	}


	private ReferenceSelectionComposite citationSelection;
	private TextWithLabelComposite microCitation;



	/* (non-Javadoc)
	 * @see org.eclipse.jface.util.IPropertyChangeListener#propertyChange(org.eclipse.jface.util.PropertyChangeEvent)
	 */
	public void propertyChange(PropertyChangeEvent event) {
		element.setCitation(citationSelection.getSelection());
		element.setCitationMicroReference(microCitation.getText());
		super.propertyChange(event);
	}


	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#createControls(org.eclipse.swt.widgets.Composite, int)
	 */
	@Override
	public void createControls(Composite parent, int style) {
		citationSelection = new ReferenceSelectionComposite(parent, "Citation", null, this, SWT.NULL);		
		microCitation = new TextWithLabelComposite(parent, "Citation Detail", null, this, SWT.NULL);
	}


	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#setElement(eu.etaxonomy.cdm.model.common.VersionableEntity)
	 */
	@Override
	public void setElement(IdentifiableSource element) {
		this.element = element;
		citationSelection.setSelection(element.getCitation());
		microCitation.setText(element.getCitationMicroReference());
	}	
}