// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.forms.selectioncomposites;

import org.apache.log4j.Logger;
import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.agent.AgentBase;
import eu.etaxonomy.taxeditor.dialogs.filteredSelection.FilteredAgentSelectionDialog;

/**
 * @author n.hoffmann
 * @created Nov 16, 2009
 * @version 1.0
 */
public class AgentSelectionComposite extends AbstractSelectionComposite<AgentBase> {
	

	private static final Logger logger = Logger
			.getLogger(AgentSelectionComposite.class);
	/**
	 * @param parent
	 * @param labelString
	 * @param selection
	 * @param listener
	 * @param style
	 */
	public AgentSelectionComposite(Composite parent, String labelString,
			AgentBase selection, IPropertyChangeListener listener, int style) {
		super(parent, labelString, selection, listener, style);
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.selectioncomposites.AbstractSelectionComposite#widgetSelected(org.eclipse.swt.events.SelectionEvent)
	 */
	@Override
	public void widgetSelected(SelectionEvent e) {
		super.widgetSelected(e);
		selection = FilteredAgentSelectionDialog.selectAgent(getShell(), selection);
		updateText();
	}

}
