/**
 * 
 */
package eu.etaxonomy.taxeditor.propertysheet;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.DialogCellEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.views.properties.PropertyDescriptor;

import eu.etaxonomy.cdm.model.common.IdentifiableEntity;

/**
 * @author p.ciardelli
 *
 */
public class ExtensionsPropertyDescriptor extends PropertyDescriptor {
	private IdentifiableEntity entity;
	
	public ExtensionsPropertyDescriptor(Object id, String displayName, IdentifiableEntity entity) {
		super(id, displayName);
		this.entity = entity;
	}

    public CellEditor createPropertyEditor(Composite parent) {
        CellEditor editor = new DialogCellEditor(parent) {

        	protected ExtensionsDialog dialog;
        	
			@Override
			protected Object openDialogBox(
					Control cellEditorWindow) {
		        dialog = new ExtensionsDialog(cellEditorWindow.getShell(), entity);
		        int returnCode = ((ExtensionsDialog) dialog).open();
				if (returnCode == Dialog.OK) {
					return new ExtensionPropertySource(entity);
				}
				return null;
			}
        	
        };
        if (getValidator() != null) {
			editor.setValidator(getValidator());
		}
        return editor;
    }	
}
