package eu.etaxonomy.taxeditor.propertysheet;

import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
import eu.etaxonomy.cdm.model.common.Marker;

public class MarkerPropertySource extends CollectionPropertySource {

	public MarkerPropertySource(AnnotatableEntity annotatableEntity) {
		super(annotatableEntity.getMarkers());		
	}
	
	@Override
	protected String getItemDisplayName(Object item) {
		// No display names on individual annotations
		return "";
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id instanceof Marker) {
			Marker marker = (Marker) id;
			return marker.getMarkerType().getLabel() + " = " + marker.getFlag();
		}
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		// Fields not editable in property sheet view
	}

	@Override
	public String toString() {
		// "Annotations" header has no value
		return "";
	}
}