/**
 * 
 */
package eu.etaxonomy.taxeditor.propertysheet;

import java.util.Set;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.DialogCellEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.ui.views.properties.PropertyDescriptor;

import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
import eu.etaxonomy.cdm.model.description.TextData;

/**
 * @author nho
 *
 */
public abstract class ProtologuePropertyDescriptor extends PropertyDescriptor {
	private TaxonNameDescription description;
	
	public ProtologuePropertyDescriptor(Object id, String displayName, TaxonNameDescription description) {
		super(id, displayName);
		this.description = description;
	}

    public CellEditor createPropertyEditor(Composite parent) {
        CellEditor editor = new DialogCellEditor(parent) {

        	protected Dialog dialog;
        	
			@Override
			protected Object openDialogBox(
					Control cellEditorWindow) {
		        dialog = new ProtologuesDialog(cellEditorWindow.getShell(), description);
		        Object result = ((ProtologuesDialog) dialog).open();
				if (result instanceof Set) {
					
					Set<TextData> protologues = (Set<TextData>) result;
					saveProtologue(protologues);
					return new ProtologuePropertySource(description);
				}
				return null;
			}
        	
        };
        if (getValidator() != null) {
			editor.setValidator(getValidator());
		}
        return editor;
    }
        
    abstract protected void saveProtologue(Set<?> set);
}
