// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.dialogs.filteredSelection;

import java.util.UUID;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.taxon.TaxonomicTree;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created Sep 21, 2009
 * @version 1.0
 */
public class FilteredTaxonomicTreeSelectionDialog extends
		AbstractFilteredCdmResourceSelectionDialog<TaxonomicTree> {
	
	private static final Logger logger = Logger
	.getLogger(FilteredTaxonomicTreeSelectionDialog.class);

	
	/**
	* @param taxon
	* @return
	*/
	public static TaxonomicTree selectTaxonomicTree(Shell shell) {
		FilteredTaxonomicTreeSelectionDialog dialog = new FilteredTaxonomicTreeSelectionDialog(shell, 
				"Choose a taxonomic tree", false, "", null);
		return getSelectionFromDialog(dialog);
	}
	
	/**
	 * @param shell
	 * @param title
	 * @param multi
	 * @param settings
	 */
	protected FilteredTaxonomicTreeSelectionDialog(Shell shell, String title,
			boolean multi, String settings, TaxonomicTree tree) {
		super(shell, title, multi, settings, tree);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.dialogs.FilteredItemsSelectionDialog#createExtendedContentArea(org.eclipse.swt.widgets.Composite)
	 */
	@Override
	protected Control createExtendedContentArea(Composite parent) {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.AbstractFilteredCdmResourceSelectionDialog#getPersistentObject(java.util.UUID)
	 */
	@Override
	protected TaxonomicTree getPersistentObject(UUID cdmUuid) {
		return CdmStore.getTaxonTreeService().getTaxonomicTreeByUuid(cdmUuid);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.AbstractFilteredCdmResourceSelectionDialog#initModel()
	 */
	@Override
	protected void initModel() {
		model = CdmStore.getTaxonTreeService().getUuidAndTitleCache();
	}
}
