// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.preference;

import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.ViewerComparator;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

import eu.etaxonomy.cdm.model.common.Language;
import eu.etaxonomy.taxeditor.store.VocabularyStore;

/**
 * @author p.ciardelli
 * @created 24.08.2009
 * @version 1.0
 */
public class LanguageMenuPreferences extends AbstractMenuPreferences<Language> {
	
	public final static String ID = "eu.etaxonomy.taxeditor.preferences.languages";
	
	/**
	 * @param initialVocabulary
	 * @param title
	 * @param description
	 */
	public LanguageMenuPreferences() {
		super(VocabularyStore.getLanguages(), 
				"Language Preferences", 
				"Configure language preferences.",
				false);
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.preference.AbstractMenuPreferences#createContents(org.eclipse.swt.widgets.Composite)
	 */
	@Override
	public Control createContents(Composite parent) {
		Control control = super.createContents(parent);
		
		tableViewer.setLabelProvider(new LanguagePreferenceLabelProvider());
		tableViewer.setComparator(new ViewerComparator());
		
		return control;
	}
		
	class LanguagePreferenceLabelProvider extends LabelProvider implements ITableLabelProvider{

		/* (non-Javadoc)
		 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object, int)
		 */
		public Image getColumnImage(Object element, int columnIndex) {
			return null;
		}

		/* (non-Javadoc)
		 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object, int)
		 */
		public String getColumnText(Object element, int columnIndex) {
			String description = ((Language)element).getDescription();
			if (description == null) {
				description = ((Language)element).getLabel() + " - Warning: no description - not shown in menus";
			}
			return description;
		}
		
		}
}
